\section{Instance Optimization}

\begin{frame}{Instance Optimization}
\textbf{Why Instance Optimization?}
\begin{itemize}
    \item Instances can be very large and contain many redundancies
    \item Reduce instance size
    \item Faster algorithm computation
    \item Potentially better (heuristic) solution quality
\end{itemize}
\textbf{Goal:} Find redundant facilities and locations
\end{frame}

\begin{frame}{Instance Optimization}
\begin{definition}[Dominated facilities/locations]
    \begin{itemize}
        \item $f$ is \alert{dominated by} $f'$ ($f\leq f'$) if
            \[B_{d_i}(f)\subseteq B_{d_i}(f') \text{\quad for all $i\in\{1,...,k\}$ with $f\in F_i$}\]
        $f$ is \alert{dominated} if $f\leq f'$ for some $f'\neq f$
        \item $v$ is \alert{dominated by} $v'$ ($v\leq v'$) if
            \[F_{d_i}(v)\cap F_i\supseteq F_{d_i}(v')\cap F_i \text{\quad for all $i\in\{1,...,k\}$}\]
        $v$ is \alert{dominated} if $v\leq v'$ for some $v'\neq v$
    \end{itemize}
    
\end{definition}

\end{frame}

\begin{frame}{Instance Optimization}
    \textbf{Observation:}
    \begin{itemize}
        \item $X$ solution, $f\in X$, $f\leq f'$ $\Rightarrow$ $X\setminus\{f\}\cup\{f'\}$ solution \\
            $\Rightarrow$ Dominated facilities are redundant
        \item $v\leq v'$, $v'$ covered $\Rightarrow$ $v$ covered \\
            $\Rightarrow$ Dominated locations are redundant \alert{if $\alpha=0$}
    \end{itemize}
    \vspace{1cm}
    \centering
    $\Rightarrow$ Remove dominated facilities and (if $\alpha=0)$ locations!
\end{frame}

\begin{frame}{Instance Optimization}
    \begin{figure}
        \centering
        \begin{tikzpicture}[scale=0.85,
            facility/.style={point, fill=Red!75, draw=Black, minimum width = 16pt},
            location/.style={point, color=Black, minimum width = 12pt}
        ]
            \def\r{2.6cm}
            \node[facility,label=$f_1$] (f1) at (-2,0) {};
            \node[facility,label=$f_2$] (f2) at (2,0) {};
        
            \node[location,label=$v_1$] (v1) at (-2.5,1.5) {};
            \onslide<1>{
            \node[location,label=$v_2$] (v2) at (-1.5,-1) {};
            \node[location,label=$v_3$] (v3) at (0,0.5) {};
            \node[location,label=$v_4$] (v4) at (0,-0.5) {};
            }
            \node[location,label=$v_5$] (v5) at (2.6,1.3) {};
            \onslide<1>{\node[location,label=$v_6$] (v6) at (2.4,-1.2) {};}
        
            \draw[draw=Red!50] (f1) circle (\r);
            \draw[draw=Red!50] (f2) circle (\r);

            \onslide<2>{}
        \end{tikzpicture}
    \end{figure}
    % \begin{columns}
    %     \begin{column}{0.5\textwidth}
    %         \centering
    %         $B_d(f_1)=\{v_1,v_2,v_3,v_4\}$ \\
    %         $B_d(f_2)=\{v_3,v_4,v_5,v_6\}$ 
    %     \end{column}
    %     \begin{column}{0.5\textwidth}
    %     \centering
    %     $F_{d}(v_1)=F_d(v_2)=\{f_1\}$ \\
    %     $F_{d}(v_3)=F_d(v_4)=\{f_1,f_2\}$\\
    %     $F_{d}(v_5)=F_d(v_6)=\{f_2\}$
    %     \end{column}
    % \end{columns}

    
\end{frame}

\begin{frame}{Instance Optimization}

    \begin{center}
        So what about $\alpha>0$?
    \end{center}

\end{frame}

\begin{frame}{Instance Optimization}
    \begin{definition}[Cover Equivalency]
        $v,w$ are \alert{cover-equivalent} ($v\sim w$) if 
            \[F_{d_i}(v)\cap F_i = F_{d_i}(w)\cap F_i \text{\quad for all $i\in\{1,...,k\}$}\]
    \end{definition}
    \begin{itemize}
        \item $\sim$ is an \alert{equivalency relation} on $V\times V$
        \item $[v]\in V/_{\sim}$ are called \alert{coverage classes}
        \item We can choose \alert{representatives} $r([v])\in [v]$ for each $[v]\in V/_{\sim}$
    \end{itemize}
    \vspace{0.5cm}
    $\Rightarrow$ \alert{Coverage Reduction} 
        \[V_{\sim}:=\{r([v])|[v]\in V/_{\sim}\}\] 
        with 
        \[p(r([v]))=\sum_{w\in [v]}p(w)\]
\end{frame}

\begin{frame}{Instance Optimization}
\begin{theorem}
    The coverage reduction yields a solution-equivalent instance.
\end{theorem}
\begin{proof}
    Omitted.
    \\ (\textbf{Idea:} $[v]$ is always either completely covered or uncovered)
\end{proof}
    
\end{frame}
\begin{frame}{Instance Optimization}
    \begin{figure}
        \centering
        \begin{tikzpicture}[scale=0.85,
            facility/.style={point, fill=Red!75, draw=Black, minimum width = 16pt},
            location/.style={point, color=Black, minimum width = 12pt}
        ]
            \def\r{2.6cm}
            \node[facility,label=$f_1$] (f1) at (-2,0) {};
            \node[facility,label=$f_2$] (f2) at (2,0) {};
        
            \node[location,label=$v_1$] (v1) at (-2.5,1.5) {};
            \onslide<1>{\node[location,label=$v_2$] (v2) at (-1.5,-1) {};}
            \node[location,label=$v_3$] (v3) at (0,0.5) {};
            \onslide<1>{\node[location,label=$v_4$] (v4) at (0,-0.5) {};}
            \node[location,label=$v_5$] (v5) at (2.6,1.3) {};
            \onslide<1>{\node[location,label=$v_6$] (v6) at (2.4,-1.2) {};}
        
            \draw[draw=Red!50] (f1) circle (\r);
            \draw[draw=Red!50] (f2) circle (\r);

            \onslide<2>{}
        \end{tikzpicture}
    \end{figure}
    % \begin{columns}
    %     \begin{column}{0.5\textwidth}
    %         \centering
    %         $B_d(f_1)=\{v_1,v_2,v_3,v_4\}$ \\
    %         $B_d(f_2)=\{v_3,v_4,v_5,v_6\}$ 
    %     \end{column}
    %     \begin{column}{0.5\textwidth}
    %     \centering
    %     $F_{d}(v_1)=F_d(v_2)=\{f_1\}$ \\
    %     $F_{d}(v_3)=F_d(v_4)=\{f_1,f_2\}$\\
    %     $F_{d}(v_5)=F_d(v_6)=\{f_2\}$
    %     \end{column}
    % \end{columns}

    
\end{frame}
